Pulp - Story #7624

Add pulpcore version to the plugin API
09/29/2020 09:55 PM - dalley

Status: CLOSED - DUPLICATE Start date:

Priority: Normal Due date:

Assignee: % Done: 0%

Category: Estimated time: 0:00 hour

Sprint/Milestone:

Platform Release: Tags:

Groomed: No Sprint:

Sprint Candidate: No Quarter:

Description

<alikins> in the plugin api, is there an equilivent to "~ from pulpcore import __ _version__ as pulp_v

ersion’ to get the pulpcore version?

<alikins> idealy without invoking 'packaging' or 'distsetutools' etc

* x9c4 has quit (Quit: Leaving)

<dkliban> alikins: https://github.com/pulp/pulpcore/blob/master/pulpcore/__init__ .py#L1
<dkliban> like that?

<dkliban> it's not part of the plugin api though

NOTE: It likely affects the release automation, make sure to update that.

Related issues:
Related to Pulp - Story #6671: As a pulpcore developer | can reliably determi... CLOSED - CURRENTRELEASE

Associated revisions

Revision b3af3ad5 - 09/29/2020 10:28 PM - dalley

Expose pulpcore_version to plugin writers

Give plugin writers a way to access the pulpcore version. This is possiblyuseful in case they want to support more than one version of the plugin API
at the same time.

closes: #7624 https://pulp.plan.io/issues/7624

History

#1 - 09/29/2020 10:29 PM - dalley
- Status changed from ASSIGNED to MODIFIED

Applied in changeset pulpcore|b3af3ad5ff15c8992e8085249e8e25905ddc2d2c¢.

#2 - 09/30/2020 11:45 AM - Imjachky

After this change, | am receiving errors while initializing my vagrant box (pulp3-source-fedora31).
pulp_rpm on the master branch:

Traceback (most recent call last):
File "/usr/local/lib/pulp/bin/django—admin", line 8, in <module>
sys.exit (execute_from_command_line())
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/core/management/__init__ .py", line 381, in ex
ecute_from_command_line
utility.execute ()
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/core/management/__init__ .py", line 357, in ex
ecute
django.setup ()
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/__init__.py", line 24, in setup
apps.populate (settings.INSTALLED_APPS)
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/apps/registry.py", line 91, in populate
app_config = AppConfig.create (entry)
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/apps/config.py", line 116, in create
mod = import_module (mod_path)

10/28/2021 1/3



https://pulp.plan.io/issues/7624
https://pulp.plan.io/projects/pulp/repository/pulpcore/revisions/b3af3ad5ff15c8992e8085249e8e25905ddc2d2c

File "/usr/lib64/python3.7/importlib/__init__.py", line 127, in import_module
return _bootstrap._gcd_import (name[level:], package, level)

File "<frozen importlib._bootstrap>", line 1006, in _gcd_import

File "<frozen importlib._bootstrap>", line 983, in _find_and_load

File "<frozen importlib._bootstrap>", line 967, in _find_and_load_unlocked

File "<frozen importlib._bootstrap>", line 677, in _load_unlocked

File "<frozen importlib._bootstrap_external>", line 728, in exec_module

File "<frozen importlib._bootstrap>", line 219, in _call_with_frames_removed

File "/home/vagrant/devel/pulp_rpm/pulp_rpm/app/__init__.py", line 1, in <module>
from pulpcore.plugin import PulpPluginAppConfig

File "/home/vagrant/devel/pulpcore/pulpcore/plugin/__init__.py", line 5, in <module>
from pulpcore import _ _version__ as pulpcore_version # noga

from 'pulpcore' (/usr/local/lib/pulp/lib64/python3.7/site-packag

ImportError: cannot import name version

es/pulpcore/__init__ .py)

pulp_container on the master branch:

Traceback (most recent call last):
File "/usr/local/lib/pulp/bin/django-admin", line 8, in <module>
sys.exit (execute_from_command_line())
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/core/management/__init__.py", line 381, in ex
ecute_from_command_line
utility.execute ()
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/core/management/__init__.py", line 357, in ex
ecute
django.setup ()
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/__init__.py", line 24, in setup
apps.populate (settings.INSTALLED_APPS)
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/apps/registry.py", line 91, in populate
app_config = AppConfig.create (entry)
File "/usr/local/lib/pulp/lib64/python3.7/site-packages/django/apps/config.py", line 116, in create
mod = import_module (mod_path)
File "/usr/lib64/python3.7/importlib/__init__.py", line 127, in import_module
return _bootstrap._gcd_import (name[level:], package, level)
File "<frozen importlib._bootstrap>", line 1006, in _gcd_import
File "<frozen importlib._bootstrap>", line 983, in _find_and_load
File "<frozen importlib._bootstrap>", line 967, in _find_and_load_unlocked
File "<frozen importlib._bootstrap>", line 677, in _load_unlocked
File "<frozen importlib._bootstrap_external>", line 728, in exec_module
File "<frozen importlib._bootstrap>", line 219, in _call_with_frames_removed
File "/home/vagrant/devel/pulp_container/pulp_container/app/__init__.py", line 1, in <module>
from pulpcore.plugin import PulpPluginAppConfig
File "/home/vagrant/devel/pulpcore/pulpcore/plugin/__init__.py", line 5, in <module>
from pulpcore import _ _version__ as pulpcore_version # noga
from 'pulpcore' (/usr/local/lib/pulp/lib64/python3.7/site-packag

ImportError: cannot import name version

es/pulpcore/__init__ .py)

Are there required any modifications from the plugin writer's perspective?
#3 - 09/30/2020 11:48 AM - Imjachky

| believe, the answer to my question is Yes. Even though it is somehow said in the changelog entry (Added a constant holding the pulpcore version
which can be imported by plugins - pulpcore.plugin.pulpcore_version), it could be announced globally at pulp-dev.

#4 - 10/20/2020 05:44 PM - ttereshc
- Sprint/Milestone set to 3.8.0

#5 - 10/21/2020 04:50 PM - ttereshc
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE

#6 - 10/21/2020 04:51 PM - dalley

- Status changed from CLOSED - CURRENTRELEASE to NEW
- Assignee deleted (dalley)

- Sprint/Milestone deleted (3.8.0)

This was merged and then reverted

#7 - 10/23/2020 04:57 PM - ttereshc
- Tracker changed from Issue to Story
- % Done set to 0

- Severity deleted (2. Medium)

- Triaged deleted (No)

#8 - 10/23/2020 04:59 PM - bmbouter

- Related to Story #6671: As a pulpcore developer | can reliably determine the version of a Django plugin added

#9 - 10/27/2020 02:34 PM - ttereshc

- Description updated

#10 - 10/27/2020 02:37 PM - bmbouter
- Status changed from NEW to CLOSED - DUPLICATE
